Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcexp.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcexp.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcexp.F90	(revision 2819)
@@ -53,9 +53,10 @@
       !!              COLUMN BELOW THE SURFACE LAYER.
       !!---------------------------------------------------------------------
+      !!
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
       !!
-      INTEGER  ::   ji, jj, jk, jl, ikt
+      INTEGER  ::   ji, jj, jk, jl, ikt, ierr
       REAL(wp) ::   zgeolpoc, zfact, zwork, ze3t, zsedpocd
-      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrbio
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrbio
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -67,4 +68,12 @@
       ENDIF
 
+      IF( l_trdtrc )  THEN
+         ALLOCATE( ztrbio(jpi,jpj,jpk) , STAT = ierr )   ! temporary save of trends
+         IF( ierr > 0 ) THEN
+            CALL ctl_stop( 'trc_exp: unable to allocate ztrbio array' )   ;   RETURN
+         ENDIF
+         ztrbio(:,:,:) = tra(:,:,:,jp_lob_no3)
+      ENDIF
+
       ! VERTICAL DISTRIBUTION OF NEWLY PRODUCED BIOGENIC
       ! POC IN THE WATER COLUMN
@@ -72,10 +81,4 @@
       ! LAYERS IS DETERMINED BY DMIN3 DEFINED IN sms_lobster.F90
       ! ----------------------------------------------------------------------
-
-      IF( l_trdtrc )THEN
-         ALLOCATE( ztrbio(jpi,jpj,jpk) )
-         ztrbio(:,:,:) = tra(:,:,:,jp_lob_no3)
-      ENDIF
-
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1
@@ -114,11 +117,9 @@
  
       ! Oa & Ek: diagnostics depending on jpdia2d !          left as example
-#if defined key_diatrc
-# if ! defined key_iomput
-      trc2d(:,:,jp_lob0_2d + 18) = sedpocn(:,:)
-# else
-     CALL iom_put( "SEDPOC" , sedpocn )
-# endif
-#endif
+      IF( ln_diatrc ) THEN
+         IF( lk_iomput ) THEN   ;   CALL iom_put( "SEDPOC" , sedpocn )
+         ELSE                   ;   trc2d(:,:,jp_lob0_2d + 18) = sedpocn(:,:)
+         ENDIF
+      ENDIF
 
       
@@ -146,7 +147,6 @@
          jl = jp_lob0_trd + 16
          CALL trd_mod_trc( ztrbio, jl, kt )   ! handle the trend
+         DEALLOCATE( ztrbio ) 
       ENDIF
-
-      IF( l_trdtrc ) DEALLOCATE( ztrbio )
 
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcnam_lobster.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcnam_lobster.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcnam_lobster.F90	(revision 2819)
@@ -12,8 +12,10 @@
    !! trc_nam_lobster   : LOBSTER model namelist read
    !!----------------------------------------------------------------------
-   USE oce_trc          ! Ocean variables
-   USE par_trc          ! TOP parameters
-   USE trc              ! TOP variables
-   USE sms_lobster      ! sms trends
+   USE oce_trc                                   ! Ocean variables
+   USE par_trc                                   ! TOP parameters
+   USE trc                                       ! TOP variables
+   USE trdmod_trc_oce , ONLY :  lk_trdmld_trc    !  tracers  trend flag
+   USE sms_lobster                               ! sms trends
+   USE iom                                       ! I/O manager
 
    IMPLICIT NONE
@@ -41,27 +43,8 @@
       INTEGER ::   numnatl
       !!
-#if defined key_diatrc && ! defined key_iomput
       INTEGER :: jl, jn
-      ! definition of additional diagnostic as a structure
-      TYPE DIAG
-         CHARACTER(len = 20)  :: snamedia   !: short name
-         CHARACTER(len = 80 ) :: lnamedia   !: long name
-         CHARACTER(len = 20 ) :: unitdia    !: unit
-      END TYPE DIAG
-
-      TYPE(DIAG) , DIMENSION(jp_lobster_2d) :: lobdia2d
-      TYPE(DIAG) , DIMENSION(jp_lobster_3d) :: lobdia3d
-#endif
-#if defined key_diabio || defined key_trdmld_trc
-      INTEGER :: js, jd
-      ! definition of additional diagnostic as a structure
-      TYPE DIABIO
-         CHARACTER(len = 20)  :: snamebio   !: short name
-         CHARACTER(len = 80 ) :: lnamebio   !: long name
-         CHARACTER(len = 20 ) :: unitbio    !: unit
-      END TYPE DIABIO
-
-      TYPE(DIABIO) , DIMENSION(jp_lobster_trd) :: lobdiabio
-#endif
+      TYPE(DIAG), DIMENSION(jp_lobster_2d )  :: lobdia2d
+      TYPE(DIAG), DIMENSION(jp_lobster_3d )  :: lobdia3d
+      TYPE(DIAG), DIMENSION(jp_lobster_trd)  :: lobdiabio
 
       NAMELIST/namlobphy/ apmin, tmumax, rgamma, fphylab, tmmaxp, tmminp, &
@@ -77,10 +60,6 @@
 
       NAMELIST/namlobopt/ xkg0, xkr0, xkgp, xkrp, xlg, xlr, rpig
-#if defined key_diatrc && ! defined key_iomput
-      NAMELIST/namlobdia/nn_writedia, lobdia3d, lobdia2d     ! additional diagnostics
-#endif
-#if defined key_diabio || defined key_trdmld_trc
-      NAMELIST/namlobdbi/nwritebio, lobdiabio
-#endif
+      NAMELIST/namlobdia/ lobdia3d, lobdia2d     ! additional diagnostics
+      NAMELIST/namlobdbi/ lobdiabio
       !!----------------------------------------------------------------------
 
@@ -278,103 +257,93 @@
       ENDIF
 
-#if defined key_diatrc && ! defined key_iomput
-
-      ! Namelist namlobdia
-      ! -------------------
-      nn_writedia = 10                   ! default values
-
-      DO jl = 1, jp_lobster_2d
-         jn = jp_lob0_2d + jl - 1
-         WRITE(ctrc2d(jn),'("2D_",I1)') jn                      ! short name
-         WRITE(ctrc2l(jn),'("2D DIAGNOSTIC NUMBER ",I2)') jn    ! long name
-         ctrc2u(jn) = ' '                                       ! units
-      END DO
-      !                                 ! 3D output arrays
-      DO jl = 1, jp_lobster_3d
-         jn = jp_lob0_3d + jl - 1
-         WRITE(ctrc3d(jn),'("3D_",I1)') jn                      ! short name
-         WRITE(ctrc3l(jn),'("3D DIAGNOSTIC NUMBER ",I2)') jn    ! long name
-         ctrc3u(jn) = ' '                                       ! units
-      END DO
-
-      REWIND( numnatl )               ! read natrtd
-      READ  ( numnatl, namlobdia )
-
-      DO jl = 1, jp_lobster_2d
-         jn = jp_lob0_2d + jl - 1
-         ctrc2d(jn) = lobdia2d(jl)%snamedia
-         ctrc2l(jn) = lobdia2d(jl)%lnamedia
-         ctrc2u(jn) = lobdia2d(jl)%unitdia
-      END DO
-
-      DO jl = 1, jp_lobster_3d
-         jn = jp_lob0_3d + jl - 1
-         ctrc3d(jn) = lobdia3d(jl)%snamedia
-         ctrc3l(jn) = lobdia3d(jl)%lnamedia
-         ctrc3u(jn) = lobdia3d(jl)%unitdia
-      END DO
-
-      IF(lwp) THEN                   ! control print
-         WRITE(numout,*)
-         WRITE(numout,*) ' Namelist : natadd'
-         WRITE(numout,*) '    frequency of outputs for additional arrays nn_writedia = ', nn_writedia
+      !
+      IF( .NOT.lk_iomput .AND. ln_diatrc ) THEN
+         !
+         ! Namelist namlobdia
+         ! -------------------
+         DO jl = 1, jp_lobster_2d
+            WRITE(lobdia2d(jl)%sname,'("2D_",I1)') jl                      ! short name
+            WRITE(lobdia2d(jl)%lname,'("2D DIAGNOSTIC NUMBER ",I2)') jl    ! long name
+            lobdia2d(jl)%units = ' '                                        ! units
+         END DO
+         !                                 ! 3D output arrays
+         DO jl = 1, jp_lobster_3d
+            WRITE(lobdia3d(jl)%sname,'("3D_",I1)') jl                      ! short name
+            WRITE(lobdia3d(jl)%lname,'("3D DIAGNOSTIC NUMBER ",I2)') jl    ! long name
+            lobdia3d(jl)%units = ' '                                        ! units
+         END DO
+
+         REWIND( numnatl )               ! read natrtd
+         READ  ( numnatl, namlobdia )
+
+         DO jl = 1, jp_lobster_2d
+            jn = jp_lob0_2d + jl - 1
+            ctrc2d(jn) = lobdia2d(jl)%sname
+            ctrc2l(jn) = lobdia2d(jl)%lname
+            ctrc2u(jn) = lobdia2d(jl)%units
+         END DO
+
          DO jl = 1, jp_lobster_3d
             jn = jp_lob0_3d + jl - 1
-            WRITE(numout,*) '   3d output field No : ',jn
-            WRITE(numout,*) '   short name         : ', TRIM(ctrc3d(jn))
-            WRITE(numout,*) '   long name          : ', TRIM(ctrc3l(jn))
-            WRITE(numout,*) '   unit               : ', TRIM(ctrc3u(jn))
+            ctrc3d(jn) = lobdia3d(jl)%sname
+            ctrc3l(jn) = lobdia3d(jl)%lname
+            ctrc3u(jn) = lobdia3d(jl)%units
+         END DO
+
+         IF(lwp) THEN                   ! control print
+            WRITE(numout,*)
+            WRITE(numout,*) ' Namelist : natadd'
+            DO jl = 1, jp_lobster_3d
+               jn = jp_lob0_3d + jl - 1
+               WRITE(numout,*) '  3d diag nb : ', jn, '    short name : ', ctrc3d(jn), &
+                 &             '  long name  : ', ctrc3l(jn), '   unit : ', ctrc3u(jn)
+            END DO
             WRITE(numout,*) ' '
-         END DO
-
-         DO jl = 1, jp_lobster_2d
-            jn = jp_lob0_2d + jl - 1
-            WRITE(numout,*) '   2d output field No : ',jn
-            WRITE(numout,*) '   short name         : ', TRIM(ctrc2d(jn))
-            WRITE(numout,*) '   long name          : ', TRIM(ctrc2l(jn))
-            WRITE(numout,*) '   unit               : ', TRIM(ctrc2u(jn))
+
+            DO jl = 1, jp_lobster_2d
+               jn = jp_lob0_2d + jl - 1
+               WRITE(numout,*) '  2d diag nb : ', jn, '    short name : ', ctrc2d(jn), &
+                 &             '  long name  : ', ctrc2l(jn), '   unit : ', ctrc2u(jn)
+            END DO
             WRITE(numout,*) ' '
-         END DO
-      ENDIF
-#endif
-
-#if defined key_diabio || defined key_trdmld_trc
-      ! namlobdbi : bio diagnostics
-      nwritebio = 10                     ! default values
-
-      DO js = 1, jp_lobster_trd
-         jd = jp_lob0_trd + js - 1
-         IF(     jd <  10 ) THEN   ;   WRITE (ctrbio(jd),'("BIO_",I1)') jd      ! short name
-         ELSEIF (jd < 100 ) THEN   ;   WRITE (ctrbio(jd),'("BIO_",I2)') jd   
-         ELSE                      ;   WRITE (ctrbio(jd),'("BIO_",I3)') jd
          ENDIF
-         WRITE(ctrbil(jd),'("BIOLOGICAL TREND NUMBER ",I2)') jd                 ! long name
-         ctrbiu(jd) = 'mmoleN/m3/s '                                            ! units
-      END DO
-
-      REWIND( numnatl )
-      READ  ( numnatl, namlobdbi ) 
+         !
+      ENDIF
+
+      IF( ( .NOT.lk_iomput .AND. ln_diabio ) .OR. lk_trdmld_trc ) THEN
+         !
+         ! Namelist namlobdbi
+         ! -------------------
+         DO jl = 1, jp_lobster_trd
+            IF(     jl <  10 ) THEN   ;   WRITE (lobdiabio(jl)%sname,'("BIO_",I1)') jl      ! short name
+            ELSEIF (jl < 100 ) THEN   ;   WRITE (lobdiabio(jl)%sname,'("BIO_",I2)') jl  
+            ELSE                      ;   WRITE (lobdiabio(jl)%sname,'("BIO_",I3)') jl
+            ENDIF
+            WRITE(lobdiabio(jl)%lname,'("BIOLOGICAL TREND NUMBER ",I2)') jl                 ! long name
+            lobdiabio(jl)%units = 'mmoleN/m3/s '                                            ! units
+         END DO
+
+         REWIND( numnatl )
+         READ  ( numnatl, namlobdbi ) 
  
-      DO js = 1, jp_lobster_trd
-         jd = jp_lob0_trd + js - 1
-         ctrbio(jd) = lobdiabio(js)%snamebio
-         ctrbil(jd) = lobdiabio(js)%lnamebio
-         ctrbiu(jd) = lobdiabio(js)%unitbio
-      END DO
-
-      IF(lwp) THEN                   ! control print
-         WRITE(numout,*)
-         WRITE(numout,*) ' Namelist : namlobdbi'
-         WRITE(numout,*) '    frequency of outputs for biological trends nwritebio = ', nwritebio
-         DO js = 1, jp_lobster_trd
-            jd = jp_lob0_trd + js - 1
-            WRITE(numout,*) '   biological trend No : ',jd
-            WRITE(numout,*) '   short name         : ', TRIM(ctrbio(jd))
-            WRITE(numout,*) '   long name          : ', TRIM(ctrbil(jd))
-            WRITE(numout,*) '   unit               : ', TRIM(ctrbiu(jd))
+         DO jl = 1, jp_lobster_trd
+            jn = jp_lob0_trd + jl - 1
+            ctrbio(jl) = lobdiabio(jl)%sname
+            ctrbil(jl) = lobdiabio(jl)%lname
+            ctrbiu(jl) = lobdiabio(jl)%units
+         END DO
+
+         IF(lwp) THEN                   ! control print
+            WRITE(numout,*)
+            WRITE(numout,*) ' Namelist : namlobdbi'
+            DO jl = 1, jp_lobster_trd
+               jn = jp_lob0_trd + jl - 1
+               WRITE(numout,*) '  biological trend No : ', jn, '    short name : ', ctrbio(jn), &
+                 &             '  long name  : ', ctrbio(jn), '   unit : ', ctrbio(jn)
+            END DO
             WRITE(numout,*) ' '
-         END DO
+         END IF
+         !
       END IF
-#endif
       !
    END SUBROUTINE trc_nam_lobster
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsed.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsed.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsed.F90	(revision 2819)
@@ -57,20 +57,13 @@
       !!---------------------------------------------------------------------
       USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
-      USE wrk_nemo, ONLY: zwork => wrk_3d_2
-      USE wrk_nemo, ONLY: zw2d  => wrk_2d_1 ! only used (if defined 
-                                            ! key_diatrc && defined key_iomput)
+      USE wrk_nemo, ONLY: zw2d  => wrk_2d_1, zwork => wrk_3d_2
       !!
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
       !!
-      INTEGER  ::   ji, jj, jk, jl
-      REAL(wp) ::   ztra
-      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrbio
+      INTEGER  ::   ji, jj, jk, jl, ierr
+      REAL(wp) ::   ztra, ze3t
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrbio
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
-
-      IF( ( wrk_in_use(3,2)) .OR. ( wrk_in_use(2,1)) ) THEN
-         CALL ctl_stop('trc_sed : requested workspace arrays unavailable.')
-         RETURN
-      END IF
 
       IF( kt == nit000 ) THEN
@@ -80,4 +73,18 @@
       ENDIF
 
+      IF( wrk_in_use(2, 1) .OR. wrk_in_use(3, 2) ) THEN
+         CALL ctl_stop('trc_sed : requested workspace arrays unavailable.')  ;  RETURN
+      END IF
+
+      IF( l_trdtrc )  THEN
+         ALLOCATE( ztrbio(jpi,jpj,jpk) , STAT = ierr )   ! temporary save of trends
+         IF( ierr > 0 ) THEN
+            CALL ctl_stop( 'trc_sed: unable to allocate ztrbio array' )   ;   RETURN
+         ENDIF
+         ztrbio(:,:,:) = tra(:,:,:,jp_lob_det)
+      ENDIF
+
+      IF( ln_diatrc .AND. lk_iomput )  zw2d(:,:) = 0.
+
       ! sedimentation of detritus  : upstream scheme
       ! --------------------------------------------
@@ -86,13 +93,4 @@
       zwork(:,:,1  ) = 0.e0      ! surface value set to zero
       zwork(:,:,jpk) = 0.e0      ! bottom value  set to zero
-
-#if defined key_diatrc && defined key_iomput
-      zw2d(:,:) = 0.
-# endif
-
-      IF( l_trdtrc )THEN
-         ALLOCATE( ztrbio(jpi,jpj,jpk) )
-         ztrbio(:,:,:) = tra(:,:,:,jp_lob_det)
-      ENDIF
 
       ! tracer flux at w-point: we use -vsed (downward flux)  with simplification : no e1*e2
@@ -104,35 +102,21 @@
       DO jk = 1, jpkm1
          DO jj = 1, jpj
-            DO ji = 1,jpi
+            DO ji = 1, jpi
                ztra  = - ( zwork(ji,jj,jk) - zwork(ji,jj,jk+1) ) / fse3t(ji,jj,jk)
                tra(ji,jj,jk,jp_lob_det) = tra(ji,jj,jk,jp_lob_det) + ztra
-#if defined key_diabio
-               trbio(ji,jj,jk,jp_lob0_trd + 7) = ztra
-#endif
-#if defined key_diatrc
-# if ! defined key_iomput
-               trc2d(ji,jj,jp_lob0_2d + 7) = trc2d(ji,jj,jp_lob0_2d + 7) + ztra * fse3t(ji,jj,jk) * 86400.
-# else
-               zw2d(ji,jj) = zw2d(ji,jj) + ztra * fse3t(ji,jj,jk) * 86400.
-# endif
-#endif
+               !
+               IF( ln_diabio )  trbio(ji,jj,jk,jp_lob0_trd + 7) = ztra
+               IF( ln_diatrc ) THEN
+                  ze3t = ztra * fse3t(ji,jj,jk) * 86400.
+                  IF( lk_iomput ) THEN   ;  zw2d(ji,jj) = zw2d(ji,jj) + ze3t 
+                  ELSE                   ;  trc2d(ji,jj,jp_lob0_2d + 7) = trc2d(ji,jj,jp_lob0_2d + 7) + ze3t
+                  ENDIF
+               ENDIF
+               !
             END DO
          END DO
       END DO
 
-#if defined key_diabio
-      jl = jp_lob0_trd + 7
-      CALL lbc_lnk (trbio(:,:,1,jl), 'T', 1. )    ! Lateral boundary conditions on trcbio
-#endif
-#if defined key_diatrc
-# if ! defined key_iomput
-      jl = jp_lob0_2d + 7
-      CALL lbc_lnk( trc2d(:,:,jl), 'T', 1. )      ! Lateral boundary conditions on trc2d
-# else
-      CALL lbc_lnk( zw2d(:,:), 'T', 1. )      ! Lateral boundary conditions on zw2d
-      CALL iom_put( "TDETSED", zw2d )
-# endif
-#endif
-      !
+      IF( ln_diatrc .AND. lk_iomput )  CALL iom_put( "TDETSED", zw2d )
 
       IF( l_trdtrc ) THEN
@@ -140,7 +124,6 @@
          jl = jp_lob0_trd + 7
          CALL trd_mod_trc( ztrbio, jl, kt )   ! handle the trend
+         DEALLOCATE( ztrbio ) 
       ENDIF
-
-      IF( l_trdtrc ) DEALLOCATE( ztrbio )
 
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
@@ -150,5 +133,5 @@
       ENDIF
 
-      IF( ( wrk_not_released(3, 2) ) .OR. ( wrk_not_released(2, 1) ) )  &
+      IF( ( wrk_not_released(2, 1) ) .OR. ( wrk_not_released(3, 2) ) )  &
        &         CALL ctl_stop('trc_sed : failed to release workspace arrays.')
 
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsms_lobster.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsms_lobster.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsms_lobster.F90	(revision 2819)
@@ -45,14 +45,9 @@
       !! ** Method  : - ???
       !! --------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
-      USE wrk_nemo, ONLY: ztrlob => wrk_3d_1   ! used for lobster sms trends
       !!
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
+      !
       INTEGER :: jn
       !! --------------------------------------------------------------------
-
-      IF( wrk_in_use(3, 1) ) THEN
-         CALL ctl_stop('trc_sms_lobster : requested workspace array unavailable')   ;   RETURN
-      ENDIF
 
       CALL trc_opt( kt )      ! optical model
@@ -62,13 +57,10 @@
 
       IF( l_trdtrc ) THEN
-          DO jn = jp_lob0, jp_lob1
-            ztrlob(:,:,:) = tra(:,:,:,jn)
-            CALL trd_mod_trc( ztrlob, jn, jptra_trd_sms, kt )   ! save trends
-          END DO
+         DO jn = jp_lob0, jp_lob1
+           CALL trd_mod_trc( tra(:,:,:,jn), jn, jptra_trd_sms, kt )   ! save trends
+         END DO
       END IF
 
       IF( lk_trdmld_trc )  CALL trd_mld_bio( kt )   ! trends: Mixed-layer
-
-      IF( wrk_not_released(3, 1) )   CALL ctl_stop('trc_sms_lobster : failed to release workspace array.')
       !
    END SUBROUTINE trc_sms_lobster
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zbio.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zbio.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zbio.F90	(revision 2819)
@@ -14,17 +14,17 @@
    !!                      compartments of PISCES
    !!----------------------------------------------------------------------
-   USE oce_trc         !
-   USE trc         ! 
-   USE sms_pisces      ! 
-   USE p4zsink         ! 
-   USE p4zopt          ! 
-   USE p4zlim          ! 
-   USE p4zprod         !
-   USE p4zmort         !
-   USE p4zmicro        ! 
-   USE p4zmeso         ! 
-   USE p4zrem          ! 
-   USE prtctl_trc
-   USE iom
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p4zsink         !  vertical flux of particulate matter due to sinking
+   USE p4zopt          !  optical model
+   USE p4zlim          !  Co-limitations of differents nutrients
+   USE p4zprod         !  Growth rate of the 2 phyto groups
+   USE p4zmort         !  Mortality terms for phytoplankton
+   USE p4zmicro        !  Sources and sinks of microzooplankton
+   USE p4zmeso         !  Sources and sinks of mesozooplankton
+   USE p4zrem          !  Remineralisation of organic matter
+   USE prtctl_trc      !  print control for debugging
+   USE iom             !  I/O manager
   
    IMPLICIT NONE
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zche.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zche.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zche.F90	(revision 2819)
@@ -17,8 +17,8 @@
    !!   p4z_che      :  Sea water chemistry computed following OCMIP protocol
    !!----------------------------------------------------------------------
-   USE oce_trc       !
-   USE trc           !
-   USE sms_pisces    ! 
-   USE lib_mpp       ! MPP library
+   USE oce_trc       !  shared variables between ocean and passive tracers
+   USE trc           !  passive tracers common variables
+   USE sms_pisces    !  PISCES Source Minus Sink variables
+   USE lib_mpp       !  MPP library
 
    IMPLICIT NONE
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zflx.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 2819)
@@ -17,13 +17,12 @@
    !!   p4z_flx_init  :   Read the namelist
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE trc
-   USE sms_pisces
-   USE prtctl_trc
-   USE p4zche
-   USE iom
+   USE oce_trc                      !  shared variables between ocean and passive tracers 
+   USE trc                          !  passive tracers common variables
+   USE sms_pisces                   !  PISCES Source Minus Sink variables
+   USE p4zche                       !  Chemical model
+   USE prtctl_trc                   !  print control for debugging
+   USE iom                          !  I/O manager
 #if defined key_cpl_carbon_cycle
-   USE sbc_oce , ONLY :  atm_co2
+   USE sbc_oce, ONLY :  atm_co2     !  atmospheric pCO2               
 #endif
 
@@ -137,8 +136,7 @@
             ! Compute the piston velocity for O2 and CO2
             zkgwan = 0.3 * zws  + 2.5 * ( 0.5246 + 0.016256 * ztc + 0.00049946  * ztc2 )
+            zkgwan = zkgwan * xconv * ( 1.- fr_i(ji,jj) ) * tmask(ji,jj,1)
 # if defined key_degrad
-            zkgwan = zkgwan * xconv * ( 1.- fr_i(ji,jj) ) * tmask(ji,jj,1) * facvol(ji,jj,1)
-#else
-            zkgwan = zkgwan * xconv * ( 1.- fr_i(ji,jj) ) * tmask(ji,jj,1)
+            zkgwan = zkgwan * facvol(ji,jj,1)
 #endif 
             ! compute gas exchange for CO2 and O2
@@ -161,30 +159,25 @@
             zflu16 = trn(ji,jj,1,jpoxy) * tmask(ji,jj,1) * zkgo2(ji,jj)
             tra(ji,jj,1,jpoxy) = tra(ji,jj,1,jpoxy) + ( zfld16 - zflu16 ) / fse3t(ji,jj,1)
-
-#if defined key_diatrc 
-            ! Save diagnostics
-#  if ! defined key_iomput
+#if defined key_iomput
+            zoflx(ji,jj) = ( zfld16 - zflu16 ) * 1000. * tmask(ji,jj,1)
+            zkg  (ji,jj) = zkgco2(ji,jj) * tmask(ji,jj,1)
+            zdpco2(ji,jj) = ( satmco2(ji,jj) - zh2co3(ji,jj) / ( chemc(ji,jj,1) + rtrn ) ) * tmask(ji,jj,1)
+            zdpo2 (ji,jj) = ( atcox  - trn(ji,jj,1,jpoxy)    / ( chemc(ji,jj,2) + rtrn ) ) * tmask(ji,jj,1)
+# else
             zfact = 1. / e1e2t(ji,jj) / rfact
             trc2d(ji,jj,jp_pcs0_2d    ) = oce_co2(ji,jj) * zfact
             trc2d(ji,jj,jp_pcs0_2d + 1) = ( zfld16 - zflu16 ) * 1000. * tmask(ji,jj,1)
             trc2d(ji,jj,jp_pcs0_2d + 2) = zkgco2(ji,jj) * tmask(ji,jj,1)
-            trc2d(ji,jj,jp_pcs0_2d + 3) = ( satmco2(ji,jj) - zh2co3(ji,jj) / ( chemc(ji,jj,1) + rtrn ) ) &
-               &                            * tmask(ji,jj,1)
-#  else
-            zoflx(ji,jj) = ( zfld16 - zflu16 ) * 1000. * tmask(ji,jj,1)
-            zkg  (ji,jj) = zkgco2(ji,jj) * tmask(ji,jj,1)
-            zdpco2(ji,jj) = ( satmco2(ji,jj) - zh2co3(ji,jj) / ( chemc(ji,jj,1) + rtrn ) ) * tmask(ji,jj,1)
-            zdpo2 (ji,jj) = ( atcox  - trn(ji,jj,1,jpoxy) / ( chemc(ji,jj,2) + rtrn ) ) * tmask(ji,jj,1)
-#  endif
-#endif
+            trc2d(ji,jj,jp_pcs0_2d + 3) = ( satmco2(ji,jj) - zh2co3(ji,jj) / ( chemc(ji,jj,1) + rtrn ) ) * tmask(ji,jj,1)
+# endif
          END DO
       END DO
 
-      t_oce_co2_flx = t_oce_co2_flx + glob_sum( oce_co2(:,:) )                     ! Cumulative Total Flux of Carbon
+      t_oce_co2_flx = t_oce_co2_flx + glob_sum( oce_co2(:,:) )            ! Cumulative Total Flux of Carbon
       IF( kt == nitend ) THEN
          t_atm_co2_flx = glob_sum( satmco2(:,:) * e1e2t(:,:) )            ! Total atmospheric pCO2
          !
-         t_oce_co2_flx = (-1.) * t_oce_co2_flx  * 12. / 1.e15                      ! Conversion in PgC ; negative for out of the ocean
-         t_atm_co2_flx = t_atm_co2_flx  / area                                     ! global mean of atmospheric pCO2
+         t_oce_co2_flx = (-1.) * t_oce_co2_flx  * 12. / 1.e15             ! Conversion in PgC ; negative for out of the ocean
+         t_atm_co2_flx = t_atm_co2_flx  / area                            ! global mean of atmospheric pCO2
          !
          IF( lwp) THEN
@@ -205,11 +198,11 @@
       ENDIF
 
-# if defined key_diatrc && defined key_iomput
-      CALL iom_put( "Cflx" , oce_co2(:,:) / e1e2t(:,:) / rfact ) 
-      CALL iom_put( "Oflx" , zoflx  )
-      CALL iom_put( "Kg"   , zkg    )
-      CALL iom_put( "Dpco2", zdpco2 )
-      CALL iom_put( "Dpo2" , zdpo2  )
-#endif
+      IF( ln_diatrc ) THEN
+         CALL iom_put( "Cflx" , oce_co2(:,:) / e1e2t(:,:) / rfact ) 
+         CALL iom_put( "Oflx" , zoflx  )
+         CALL iom_put( "Kg"   , zkg    )
+         CALL iom_put( "Dpco2", zdpco2 )
+         CALL iom_put( "Dpo2" , zdpo2  )
+      ENDIF
       !
       IF( wrk_not_released(2, 1,2,3,4,5,6,7) )   CALL ctl_stop('p4z_flx: failed to release workspace arrays')
@@ -231,6 +224,6 @@
       !!----------------------------------------------------------------------
       !
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampisext )
+      REWIND( numnatp )                     ! read numnatp
+      READ  ( numnatp, nampisext )
       !
       IF(lwp) THEN                         ! control print
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zint.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zint.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zint.F90	(revision 2819)
@@ -13,7 +13,7 @@
    !!   p4z_int        :  interpolation and computation of various accessory fields
    !!----------------------------------------------------------------------
-   USE oce_trc         !
-   USE trc
-   USE sms_pisces
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
 
    IMPLICIT NONE
@@ -21,9 +21,4 @@
 
    PUBLIC   p4z_int  
-   PUBLIC   p4z_int_alloc
-
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   tgfunc    !: Temp. dependancy of various biological rates
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   tgfunc2   !: Temp. dependancy of mesozooplankton rates
-
    REAL(wp) ::   xksilim = 16.5e-6_wp   ! Half-saturation constant for the Si half-saturation constant computation
 
@@ -41,8 +36,7 @@
       !! ** Purpose :   interpolation and computation of various accessory fields
       !!
-      !! ** Method  : - ???
       !!---------------------------------------------------------------------
-      INTEGER  ::   ji, jj
-      REAL(wp) ::   zdum
+      INTEGER  ::   ji, jj                 ! dummy loop indices
+      REAL(wp) ::   zvar                   ! local variable
       !!---------------------------------------------------------------------
 
@@ -57,6 +51,6 @@
       DO ji = 1, jpi
          DO jj = 1, jpj
-            zdum = trn(ji,jj,1,jpsil) * trn(ji,jj,1,jpsil)
-            xksimax(ji,jj) = MAX( xksimax(ji,jj), ( 1.+ 7.* zdum / ( xksilim * xksilim + zdum ) ) * 1e-6 )
+            zvar = trn(ji,jj,1,jpsil) * trn(ji,jj,1,jpsil)
+            xksimax(ji,jj) = MAX( xksimax(ji,jj), ( 1.+ 7.* zvar / ( xksilim * xksilim + zvar ) ) * 1e-6 )
          END DO
       END DO
@@ -68,15 +62,4 @@
       !
    END SUBROUTINE p4z_int
-
-
-   INTEGER FUNCTION p4z_int_alloc()
-      !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE p4z_int_alloc  ***
-      !!----------------------------------------------------------------------
-      ALLOCATE( tgfunc(jpi,jpj,jpk), tgfunc2(jpi,jpj,jpk), STAT=p4z_int_alloc )
-      !
-      IF( p4z_int_alloc /= 0 )   CALL ctl_warn('p4z_int_alloc : failed to allocate arrays.')
-      !
-   END FUNCTION p4z_int_alloc
 
 #else
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlim.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlim.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlim.F90	(revision 2819)
@@ -14,8 +14,7 @@
    !!   p4z_lim_init   :   Read the namelist 
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE trc         ! 
-   USE sms_pisces      ! 
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
 
    IMPLICIT NONE
@@ -184,6 +183,6 @@
          &             concnnh4, concdnh4, xksi1, xksi2, xkdoc, caco3r
 
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampislim )
+      REWIND( numnatp )                     ! read numnat
+      READ  ( numnatp, nampislim )
 
       IF(lwp) THEN                         ! control print
